/** @module stately-react */
import * as React from 'react';
import { Reducer, Middleware, Action } from 'redux';
export interface ControllerProps<State> {
    state: State;
    dispatch: <A extends Action>(action: A) => void;
}
export declare type ControllableChildren<State> = (state: State, dispatch: <A extends Action>(action: A) => void) => React.ReactNode;
export interface ControllableProps<State> {
    children: ControllableChildren<State>;
}
export declare type Controller<State> = React.ComponentType<ControllerProps<State>>;
export declare type Controllable<State> = React.ComponentType<ControllableProps<State>>;
export interface ControllableContext<State> {
    Controller: Controller<State>;
    Controllable: Controllable<State>;
}
export declare function createControllableContext<State>(reducer: Reducer<State>, middleware?: Middleware): ControllableContext<State>;
